module.exports = create;

function create (brick, selector, source, binder) {
  if (typeof selector == 'object') {
    return each(brick, selector);
  }

  if (!brick.bindings) brick.bindings = {};

  var options = source;
  var selectorParts;
  var opt;

  if (Array.isArray(options) && options[0].isBrick) {
    options = embedded(brick, options);
  }

  if (options.isBrick || options.returnsTemplateStream) {
    options = {
      _html: source.render()
    };
  }

  if (typeof options == 'function') {
    options = options();
  }

  if (binder && brick.element) {
    binder(brick.element[0], selector, source);
  }

  brick.bindings[selector] = {
    selector: selector,
    source: source,
    binder: binder,
    options: options
  };
}

function embedded (brick, children) {
  brick.embed[children[0].key] = [];

  return children.map(function (child) {
    child.parent = brick;
    brick.embed[child.key].push(child);

    return {
      ':first': {
        'data-id': child.id,
        '_html': child.render()
      }
    };
  });
}

function each (brick, bindings) {
  var selector;
  for (selector in bindings) {
    create(brick, selector, bindings[selector]);
  }
}
