var Struct = require("new-struct");
var ready = require("./setup").ready;
var render = require("./render");

module.exports = createClass;

function createClass (object, embed) {
  !object && (object = {});
  object.New = New;

  //var Brick = require('../');
  var Mixed = Struct(Brick, object || {});

  Mixed.isBrick = true;

  return Mixed;

  function New (options) {
    options || (options = {});

    options.title = Mixed.meta.title;
    options.key = Mixed.meta.key;
    options.assetsDir = Mixed.meta.assetsDir;
    options.source = Mixed.meta.source;
    options.name = Mixed.meta.name;

    embed && (options.embed = embed);

    var brick = Mixed.With(Brick.New(options));

    setup(brick);

    return brick;
  };
}

function setup (brick) {
  if (!brick.update && !brick.setup) {
    setupDOM(brick);
    return ready(brick);
  }

  if (!brick.update) {
    brick.setup();
    setupDOM(brick);
    return ready(brick);
  }

  brick.update(function (error) {
    if (error) return brick.onError.publish(error);

    if (brick.setup) brick.setup();

    setupDOM(brick);

    ready(brick);
  });
}

function setupDOM (brick) {
  var parent = brick.element[0];
  var current = parent.children;
  var replace = render.body(brick);

  var i = -1;
  var len = replace.length;
  var dirty;

  while (++i < len) {
    if (current[i].isEqualNode(replace[i])) continue;

    dirty = current[i].children.length != replace[i].children.length
      || current[i].outerHTML != replace[i].outerHTML;

    if (!dirty) continue;

    if (!current[i]) return parent.appendChild(replace[i]);

    parent.replaceChild(replace[i], current[i]);
  }
}
