var format = require("format-text");
var filenameId = require("filename-id");
var domquery = require("domquery");
var pubsub = require("pubsub");

var instanceCounter = 1;

module.exports = New;

function New (options) {
  var Brick = require('../');

  options || (options = {});

  var brick = Brick(options);

  brick.isBrick = true;

  var element;
  if (options.dom && options.dom.key == options.key) {
    element = document.getElementById(options.dom.id.splice(0, 1)[0]);
  }

  brick.element = element ? domquery(element) : domquery('<div id="{id}">\n{content}</div>', {
    id: brick.id,
    content: ''
  });

  brick.templates = {};

  brick.embed = createChildren(brick, options.embed, options.dom);

  var id;
  var key;
  for (key in brick.source.html) {
    id = filenameId(key);
    brick.templates[id] = template(brick.source.html[key], {
      'brick:assets-dir': brick.assetsDir
    });
  }

  brick.onReady = pubsub();
  brick.onError = pubsub();

  return brick;
}

function template (source, context) {
  return function () {
    return format(source, context);
  }
}

function createChildren (brick, embed, dom) {
  var result = {};

  if (!embed) return;

  Array.prototype.forEach.call(embed, function (c) {
    result[c.meta.key] = c.New({
      parent: brick,
      dom: dom.embed ? dom.embed[c.meta.key] : undefined
    });
  });

  return result;
}
