module.exports = setup;
module.exports.ready = ready;

function setup (brick) {
  if (!brick.update && !brick.setup) return ready(brick);

  if (!brick.update) {
    brick.setup();
    return ready(brick);
  }

  brick.update(function (error) {
    if (error) return brick.onError.publish(error);

    if (brick.setup) brick.setup();

    ready(brick);
  });
}

function ready (brick) {
  var onReady = brick.onReady;

  brick.onReady = function (fn) {
    fn();
  };

  brick.onReady.subscribe = brick.onReady;

  onReady.publish();
}
